<?php
/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\NormalFeedingsService;

class NormalFeedingsController extends \Zeedhi\Framework\Controller\Simple {

    protected $normalFeedingsService;

    public function __construct(NormalFeedingsService $normalFeedingsService) {
        $this->normalFeedingsService = $normalFeedingsService;
    }

    public function save(Request\DataSet $request, Response $response) {

        $normalFeedings = $request->getDataSet()->getRows();
        if($normalFeedings) {

            try {

                $dataSet = $this->normalFeedingsService->save($normalFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };

        }

    }
    
    public function delete(Request\DataSet $request, Response $response){
        $normalFeedings = $request->getDataSet()->getRows();
        if($normalFeedings) {
            try {
                $dataSet = $this->normalFeedingsService->delete($normalFeedings);
                if(sizeof($dataSet) != 0){
                    $response->addDataSet(new DataSet('error', $dataSet));
                }
            } catch(\Exception $e) {
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            };

        }
    }
}