(function() {
    angular.module("ZeedhiApp").config(function($httpProvider) {
        if (Boolean(window.applicationVersion)) {
            $httpProvider.interceptors.push(function() {
                return {
                    'request': function cacheBypass(config) {
                        if (config && config.url && shouldApplyBypass(config.url)) {
                            if (config.url.indexOf('?') !== -1) {
                                config.url += '&';
                            } else {
                                config.url += '?';
                            }
                            config.url += 'v='+window.applicationVersion;
                        }
                        return config;
                    }
                };
            });
        } else {
            console.warn('Missing "applicationVersion" global property for CacheBypass.');
        }
    });

    function shouldApplyBypass(url) {
        const urlWithoutParams = url.split('?')[0];
        return (
            Util.stringEndsWith(urlWithoutParams, '.json') ||
            Util.stringEndsWith(urlWithoutParams, '.html') ||
            Util.stringEndsWith(urlWithoutParams, '.svg')
        );
    }
})();
