var BedsRepository = function(RepositoryFactory, ContextRegister, Query) {
    var VacantBedsRepository = RepositoryFactory.factory('/BedsPrescriptions', 'LOCAL');
    var OccupiedBedsRepository = RepositoryFactory.factory('/Beds', 'LOCAL');

    this.findFromVacantBeds = function() {
        return VacantBedsRepository.find(Query.build());
    };
    this.findOneFromVacantBeds = function(bedId) {
        return VacantBedsRepository.findOne(Query.build().where('bed').equals(bedId));
    };
    this.saveInVacantBeds = function(bed) {
        return VacantBedsRepository.save(bed);
    };
    this.removeFromVacantBeds = function(bed) {
        return VacantBedsRepository.remove(bed);
    };

    this.findFromOccupiedBeds = function() {
        return OccupiedBedsRepository.find(Query.build());
    };
    this.findOneFromOccupiedBeds = function(bedId) {
        return OccupiedBedsRepository.findOne(Query.build().where('bed').equals(bedId));
    };
    this.saveInOccupiedBeds = function(bed) {
        return OccupiedBedsRepository.save(bed);
    };
    this.removeFromOccupiedBeds = function(bed) {
        return OccupiedBedsRepository.remove(bed);
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('BedsRepository', BedsRepository);
});
