function TecDietStripeMC($scope, $timeout, eventAggregator) {
 
    this.filterList = [];
    
    var widget = $scope.widget;
    var fieldList    = widget.fields;
    var mainWidget   = $scope.widget.container.getWidget('WidgetMain');
    var stripeWidget = $scope.widget.container.getWidget('WidgetStripe');
    var hallField    = widget.getField('hallName');
    var bedField     = widget.getField('bedName');
    var foodField = widget.getField('foodType');
    stripeWidget.choosedOptions = {foodType: 'TodosOsTipos'};
    widget.isHospitalized = true;
    
    $scope.changeFilterList = function (field) {
        var choosedOption = stripeWidget.choosedOptions[field.name];
        var fieldName = field.name;
        var choosedOptionJson = stringToJson(choosedOption);
        
        if(choosedOptionJson){
            choosedOption = choosedOptionJson;
            setFilter(choosedOption, field.filterBy, field);
        }else{
            switch (choosedOption){
                case "TodosOsLeitos":
                    allBeds(fieldName);
                break; 
                
                case "TodasAsAlas":
                    allHalls(fieldName);
                break;
                
                case "TodosOsAndares":
                    allStoreys();
                    reset();
                    // widget.choosedOptions[foodField.name] = 'Internados';
                    // mainWidget.dataSourceFilter = makeDataSourceFilter('situation', 'INTERNADO');
                    mainWidget.reload();
                break;
            }
        }
        // if(!hasPatientInFilter()){
        //     mainWidget.dataSourceFilter.push({"name": "situation", "operator": "=", "value": "INTERNADO"});
        //     mainWidget.reload();
        // }
        removeTextFilter();
    };
    
    function allStoreys(){
        widget.choosedOptions = {
            storeyName:   "TodosOsAndares",
            hallName:     "TodasAsAlas",
            bedName:      "TodosOsLeitos",
            foodType:  widget.choosedOptions[foodField.name]
        };
        hallField.dataSource.name = "/HallsDistincts";
        hallField.reload();
        reloadFields(widget);
    }
    function reset(){
        var defaultFilter  = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
        for(var i=1; i<fieldList.length; i++){
            fieldList[i].dataSourceFilter = defaultFilter;
            fieldList[i].reload();
        }
    }
    function allBeds(fieldName){
        if(stripeWidget.choosedOptions['hallName']){
            var value = valueJson('hallName');
            mainWidget.dataSourceFilter = makeDataSourceFilter('hall', value);
            
            value = valueJson('storeyName');
            mainWidget.dataSourceFilter.push({ "name": "storey", "operator": "=", "value": value });
            
            stripeWidget.getField(fieldName).reload();
            
        }else{
            if(stripeWidget.choosedOptions['storeyName']){
                value = valueJson('storeyName');
                mainWidget.dataSourceFilter = makeDataSourceFilter('storey', value);
            }else{
                mainWidget.dataSourceFilter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
            }
        }
        stripeWidget.choosedOptions[fieldName] = 'TodosOsLeitos';
        mainWidget.reload();
    }
    
    function allHalls(fieldName){
        if(stripeWidget.choosedOptions['storeyName'] !== "TodosOsAndares" && stripeWidget.choosedOptions['storeyName']){
            var value = valueJson('storeyName');
            mainWidget.dataSourceFilter = makeDataSourceFilter('storey', value);
            bedField.dataSourceFilter = makeDataSourceFilter('storey', value);
        }else{
            mainWidget.dataSourceFilter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
            // mainWidget.dataSourceFilter.push({"name": "situation", "operator": "=", "value": "INTERNADO"});
            bedField.dataSourceFilter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
        }
        
        stripeWidget.choosedOptions[fieldName] = 'TodasAsAlas';
        stripeWidget.choosedOptions['bedName'] = 'TodosOsLeitos';
        bedField.reload();
        mainWidget.reload();
    }
    
    function valueJson(name){
        var option = stringToJson(stripeWidget.choosedOptions[name]);
        if(typeof option === "object"){
            switch (name) {
                case 'hallName':
                    return option.hall;
                break;
                case 'storeyName':
                    return option.storey;
                break;
                case 'bedName':
                    return option.bed;
                break;
            }
        }else{
            return stripeWidget.choosedOptions[name];
        }
    }
    
    
    function stringToJson(string){
        try{
            return JSON.parse(string);
        }catch (e){
            return false;
        } 
    }
    
    function setFilter(referenceValue, referenceName, referenceField){
        if (referenceName === 'storey') {
            var filter = [{name: referenceField.filterBy, operator: "=", value: referenceValue.storey}];
            
            for(var i=1; i<fieldList.length; i++){
                fieldList[i].dataSourceFilter = filter;
                fieldList[i].reload();
            }
            stripeWidget.choosedOptions['hallName'] = 'TodasAsAlas';
            stripeWidget.choosedOptions['bedName'] = 'TodosOsLeitos';
            mainWidget.dataSourceFilter = makeDataSourceFilter(referenceField.filterBy, referenceValue.storey);
            hallField.dataSource.name = "/Halls";
            hallField.reload();
        }else if(referenceName === 'hall'){
            stripeWidget.choosedOptions['bedName'] = 'TodosOsLeitos';
            mainWidget.dataSourceFilter = makeDataSourceFilter(referenceField.filterBy, referenceValue.hall);
            bedField.dataSourceFilter = makeDataSourceFilter(referenceField.filterBy, referenceValue.hall);
            
            if(referenceValue.storey){
                mainWidget.dataSourceFilter.push({"name": "storey", "operator": "=", "value": referenceValue.storey});
                bedField.dataSourceFilter.push({"name": "storey", "operator": "=", "value": referenceValue.storey});
            }else{
                stripeWidget.choosedOptions['storeyName'] = 'TodosOsAndares';
            }
            
            bedField.reload();
        }else{
            stripeWidget.choosedOptions['storeyName'] = referenceValue.storey;
            stripeWidget.choosedOptions['hallName'] = referenceValue.hall;
            hallField.dataSource.name = "/Halls";
            hallField.dataSourceFilter = makeDataSourceFilter('storey', referenceValue.storey);
            hallField.reload();
            mainWidget.dataSourceFilter = makeDataSourceFilter(referenceName, referenceValue.bed);
        }
        // stripeWidget.choosedOptions['foodType'] = 'Internados';
        mainWidget.reload();
    }
    

    eventAggregator.subscribe('reloadScreenAndClearFilters', function (widget) {
        var detailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        if (detailsPatient) {
            detailsPatient.isVisible = false;
            detailsPatient.container.showMenu = true;
        }
        widget.typeSearch = '';
        stripeWidget.isHospitalized = true;
        hallField.dataSource.name = "/HallsDistincts";
        reloadFields(widget);
        clearFilters();
        removeCss();
        mainWidget.activate();
    });
    
    function reloadFields(widget){
        fieldList.forEach(function(stripeField){
            stripeField.reload();
        });
    }
    
    function makeDataSourceFilter(name, value){
        var dataSourceFilter = [ {
            "name": name,
            "operator": "=",
            "value": value
        }];
        return dataSourceFilter;
    }
    
    function clearFilters() {
        var filter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
        
        fieldList.forEach(function (sf) {
            sf.dataSourceFilter = filter;
            sf.reload();
            stripeWidget.choosedOptions[sf.name] = sf.filterAll;
        });
        mainWidget.dataSourceFilter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
        mainWidget.dataSourceFilter.push(
            {
                "name": [
                    {
                        "name": "formattedName",
                        "direction": "ASC"
                    }
                ],
                "operator": "ORDER_BY",
                "value": ""
            }
        );
        mainWidget.reload();
    }
    
    $scope.foodTypeChange = function(field){
        removeTextFilter();
        var typeFilter = field.widget.choosedOptions[field.name];
        if(typeFilter === 'TodosOsTipos'){
            allStoreys();
            widget.isHospitalized = true;
            clearFilters();
            removeCss();
            mainWidget.dataSourceFilter = makeDataSourceFilter('unit', getLocalVar('__CDFILIAL'));
            field.widget.choosedOptions[field.name] = 'TodosOsTipos';
        }else{
            addCss();
            widget.isHospitalized = false;
            if(!mainWidget.dataSourceFilter){
                mainWidget.dataSourceFilter = makeDataSourceFilter("situation", typeFilter);
            } else if(mainWidget.dataSourceFilter.length === 0) {
                mainWidget.dataSourceFilter.push({"name": "situation", "operator": "=", "value": typeFilter});
            } else {
                mainWidget.dataSourceFilter.forEach(function(filtro){
                   if(filtro.name === "situation"){
                       filtro.operator = "=";
                       filtro.value = typeFilter;
                   }
                });
            }
        }
        mainWidget.reload();
    };
    function removeCss(){
        for(var i =0; i<3; i++){
            $('#idFilter_'+fieldList[i].name).removeClass('alterado');
            widget.choosedOptions[fieldList[i].name] = '';
        }
    }
    function addCss(){
        for(var i =0; i<3; i++){
            if(!$('#idFilter_'+fieldList[i].name).hasClass('alterado')){
                $('#idFilter_'+fieldList[i].name).addClass('alterado');
                widget.choosedOptions[fieldList[i].name] = fieldList[i].filterAll;
            }
        }
    }
    
    function hasPatientInFilter(){
        var has = false;
        if(mainWidget.dataSourceFilter){
            mainWidget.dataSourceFilter.forEach(function(filtro){
               if(filtro.name === "situation"){
                   has = true;
               } 
            });
        }
        return has;
    }
    
    function removeTextFilter(){
        mainWidget.typeSearch = '';
        mainWidget.dataSourceFilter.splice(
            mainWidget.dataSourceFilter.indexOf(
                mainWidget.dataSourceFilter.filter(function(index){
                    index.name === "formattedName";
                })[0]),
        1);
    }
}